#ifndef STATUS_H
#define STATUS_H

#include <stdio.h>

#include <string>
#include <map>
#include <list>

#include "portable.h"

struct Work {
	uint8_t  id[16];
	uint64_t code[8];
	uint64_t key[8];
	uint32_t count;
	uint32_t block;
	uint32_t time;
};

struct Range {
	
	bool operator<(const Range &arg)
	{
		if(this->head < arg.head){
			return true;
		}

		if(this->head > arg.head){
			return false;
		}

		if(this->tail < arg.tail){
			return true;
		}

		return false;
	}
	
	uint32_t head;
	uint32_t tail;
};

class Status
{
public:
	Status();
	virtual ~Status();

	bool load(int fd);
	void save(int fd);

	std::list<Work> getBlock(std::string &id, int count);
	int report(std::string &id, Work &unit);

	bool cancel(uint32_t block);
	
	void updateImage(int workingClient);

	void debug();
	
protected:

	std::map<uint32_t, Work> work;
	std::list<Range> complete;
	
};

#endif // STATUS_H

